diff --git a/docs/en_US/backup_dialog.rst b/docs/en_US/backup_dialog.rst
index 182fb48c0..56ef32a47 100644
--- a/docs/en_US/backup_dialog.rst
+++ b/docs/en_US/backup_dialog.rst
@@ -4,7 +4,7 @@
 `Backup Dialog`:index:
 **********************
 
-Using the *pg_dump* utility, *pgAdmin* provides an easy way to create a backup
+*pgAdmin* uses the *pg_dump* utility to provide an easy way to create a backup
 in a plain-text or archived format.  You can then use a client application (like
 *psql* or the *Query Tool*) to restore a plain-text backup file, or use the
 Postgres *pg_restore* utility to restore an archived backup. The *pg_dump*
@@ -205,14 +205,15 @@ command:
 
 Use the **Stop Process** button to stop the Backup process.
 
-If the backup is successful, a popup window will confirm success. Click *Click
-here for details* on the popup window to launch the *Process Watcher*. The
-*Process Watcher* logs all the activity associated with the backup and provides
-additional information for troubleshooting.
+If the backup is successful, a popup window will confirm success. Click *More details* on the popup window to launch the *Process Watcher*. The *Process Watcher* logs all the activity associated with the backup and provides additional information for troubleshooting.
 
 .. image:: images/backup_process_watcher.png
     :alt:  Backup process watcher
     :align: center
 
 If the backup is unsuccessful, you can review the error messages returned by the
-backup command on the *Process Watcher*.
\ No newline at end of file
+backup command on the *Process Watcher*.
+
+.. note:: If you are running *pgAdmin* in *Server Mode* you can click on the |sm_icon| icon in the process watcher window to open the file location in the Storage Manager. You can use the :ref:`Storage Manager <storage_manager>` to download the backup file on the client machine .
+
+.. |sm_icon| image:: images/sm_icon.png
diff --git a/docs/en_US/backup_globals_dialog.rst b/docs/en_US/backup_globals_dialog.rst
index cc3d14328..32c8310fc 100644
--- a/docs/en_US/backup_globals_dialog.rst
+++ b/docs/en_US/backup_globals_dialog.rst
@@ -50,4 +50,8 @@ additional information for troubleshooting.
     :align: center
 
 If the backup is unsuccessful, review the error message returned by the
-*Process Watcher* to resolve any issue.
\ No newline at end of file
+*Process Watcher* to resolve any issue.
+
+.. note:: If you are running *pgAdmin* in *Server Mode* you can click on the |sm_icon| icon in the process watcher window to open the file location in the Storage Manager. You can use the :ref:`Storage Manager <storage_manager>` to download the backup file on the client machine .
+
+.. |sm_icon| image:: images/sm_icon.png
diff --git a/docs/en_US/backup_server_dialog.rst b/docs/en_US/backup_server_dialog.rst
index fae419654..11b1dec62 100644
--- a/docs/en_US/backup_server_dialog.rst
+++ b/docs/en_US/backup_server_dialog.rst
@@ -135,4 +135,8 @@ additional information for troubleshooting.
     :align: center
 
 If the backup is unsuccessful, review the error message returned by the
-*Process Watcher* to resolve any issue.
\ No newline at end of file
+*Process Watcher* to resolve any issue.
+
+.. note:: If you are running *pgAdmin* in *Server Mode* you can click on the |sm_icon| icon in the process watcher window to open the file location in the Storage Manager. You can use the :ref:`Storage Manager <storage_manager>` to download the backup file on the client machine .
+
+.. |sm_icon| image:: images/sm_icon.png
diff --git a/docs/en_US/images/delete.png b/docs/en_US/images/delete.png
new file mode 100644
index 0000000000000000000000000000000000000000..e5936e8278aa04251a7b1d6cc1d85b207330aea4
GIT binary patch
diff --git a/docs/en_US/images/download.png b/docs/en_US/images/download.png
new file mode 100644
index 0000000000000000000000000000000000000000..b3efacc7460585684d24b3d7541a8a1c02ec6c26
GIT binary patch
diff --git a/docs/en_US/images/edit.png b/docs/en_US/images/edit.png
new file mode 100644
index 0000000000000000000000000000000000000000..a52560bbf3eeab7efd3574e430df65a18a04ece6
GIT binary patch
diff --git a/docs/en_US/images/folder.png b/docs/en_US/images/folder.png
new file mode 100644
index 0000000000000000000000000000000000000000..473632c4631659932ab07c0e0d5f8ce240870b62
GIT binary patch
diff --git a/docs/en_US/images/gridview.png b/docs/en_US/images/gridview.png
new file mode 100644
index 0000000000000000000000000000000000000000..41edbac36fa202c6a0eb73d019fb5782dfb0de57
GIT binary patch
diff --git a/docs/en_US/images/home.png b/docs/en_US/images/home.png
new file mode 100644
index 0000000000000000000000000000000000000000..6c671548c95a975444ee08cef73561655ae27068
GIT binary patch
diff --git a/docs/en_US/images/process_watcher_storage_manager.png b/docs/en_US/images/process_watcher_storage_manager.png
new file mode 100644
index 0000000000000000000000000000000000000000..11c73de062ac374bbddac189427fabc8529ff443
GIT binary patch
diff --git a/docs/en_US/images/refresh.png b/docs/en_US/images/refresh.png
new file mode 100644
index 0000000000000000000000000000000000000000..58738a14da43cde8394a1158a967755cb5535d11
GIT binary patch
diff --git a/docs/en_US/images/sm_icon.png b/docs/en_US/images/sm_icon.png
new file mode 100644
index 0000000000000000000000000000000000000000..13522104e7abefcb0da49be64bfac05dbe296721
GIT binary patch
diff --git a/docs/en_US/images/storage_manager.png b/docs/en_US/images/storage_manager.png
new file mode 100644
index 0000000000000000000000000000000000000000..4ad42ce91f4b9315af008e771757a562c3d46af7
GIT binary patch
diff --git a/docs/en_US/images/tableview.png b/docs/en_US/images/tableview.png
new file mode 100644
index 0000000000000000000000000000000000000000..0191c4fe619187ae00327f758dbfda86fc3f732b
GIT binary patch
diff --git a/docs/en_US/images/uparrow.png b/docs/en_US/images/uparrow.png
new file mode 100644
index 0000000000000000000000000000000000000000..3c4303d859e1a59848c6269b2da24d1755dd1560
GIT binary patch
diff --git a/docs/en_US/images/upload.png b/docs/en_US/images/upload.png
new file mode 100644
index 0000000000000000000000000000000000000000..ec9d0eb80fe819efd123c42526c2ed5cb597a7c1
GIT binary patch
diff --git a/docs/en_US/import_export_data.rst b/docs/en_US/import_export_data.rst
index d0b67697a..963e8958b 100644
--- a/docs/en_US/import_export_data.rst
+++ b/docs/en_US/import_export_data.rst
@@ -94,3 +94,8 @@ that performed the import or export:
 .. image:: images/import_export_pw.png
     :alt: Import Export data process watcher
     :align: center
+
+.. note:: If you are running *pgAdmin* in *Server Mode* you can click on the |sm_icon| icon in the process watcher window to open the file location in the Storage Manager. You can use the :ref:`Storage Manager <storage_manager>` to download the backup file on the client machine .
+
+
+.. |sm_icon| image:: images/sm_icon.png
diff --git a/docs/en_US/management_basics.rst b/docs/en_US/management_basics.rst
index 945f2f531..ac1ea019e 100644
--- a/docs/en_US/management_basics.rst
+++ b/docs/en_US/management_basics.rst
@@ -15,4 +15,5 @@ granting user privileges, and performing VACUUM, ANALYZE and REINDEX functions.
    change_password_dialog
    grant_wizard
    import_export_data
-   maintenance_dialog
\ No newline at end of file
+   maintenance_dialog
+   storage_manager
diff --git a/docs/en_US/menu_bar.rst b/docs/en_US/menu_bar.rst
index 5400fa817..ed4acdf01 100644
--- a/docs/en_US/menu_bar.rst
+++ b/docs/en_US/menu_bar.rst
@@ -114,6 +114,8 @@ Use the *Tools* menu to access the following options (in alphabetical order):
 +---------------------------+-------------------------------------------------------------------------------------------------------------------------------------------+
 | *Resume replay of WAL*    | Click to resume the replay of the WAL log.                                                                                                |
 +---------------------------+-------------------------------------------------------------------------------------------------------------------------------------------+
+| *Storage Manager*         | Click to open the :ref:`Storage Manager <storage_manager>` to upload, delete, or download the backup files.                               |
++---------------------------+-------------------------------------------------------------------------------------------------------------------------------------------+
 
 The Help Menu
 *************
@@ -137,7 +139,3 @@ information about the pgAdmin installation (in alphabetical order):
 +----------------------+-----------------------------------------------------------------------------------------------------------------------------------------+
 | *PostgreSQL Website* | Click to access the PostgreSQL core documentation hosted at the PostgreSQL site. The site also offers guides, tutorials, and resources. |
 +----------------------+-----------------------------------------------------------------------------------------------------------------------------------------+
-
-
-
-
diff --git a/docs/en_US/storage_manager.rst b/docs/en_US/storage_manager.rst
new file mode 100644
index 000000000..2ba5cd01a
--- /dev/null
+++ b/docs/en_US/storage_manager.rst
@@ -0,0 +1,71 @@
+.. _storage_manager:
+
+************************
+`Storage Manager`:index:
+************************
+
+*Storage Manager* is a feature that helps you manage your systems storage device. You can use *Storage Manager* to:
+
+* download, upload, or manage operating system files. To use this feature, *pgAdmin* must be running in *Server Mode* on your client machine. 
+* download *backup* or *export* files (custom, tar and plain text format) on a client machine. 
+* download *export* dump files of tables.
+
+You can access *Storage Manager* from the *Tools* Menu.
+
+.. image:: images/storage_manager.png
+    :alt: Storage Manager
+    :align: center
+
+Use icons on the top of the *Storage Manager* window to manage storage:
+
+Use the ``Home`` icon |home| to return to the home directory.
+
+.. |home| image:: images/home.png
+
+Use the ``Up Arrow`` icon |uparrow| to return to the previous directory.
+
+.. |uparrow| image:: images/uparrow.png
+
+Use the ``Refresh`` icon |refresh| to display the most-recent files available.
+
+.. |refresh| image:: images/refresh.png
+
+Select the ``Download`` icon |download| to download the selected file.
+
+.. |download| image:: images/download.png
+
+Select the ``Delete`` icon |delete| to delete the selected file or folder.
+
+.. |delete| image:: images/delete.png
+
+Select the ``Edit`` icon |edit|  to rename a file or folder.
+
+.. |edit| image:: images/edit.png
+
+Use the ``Upload`` icon |upload| to upload a file.
+
+.. |upload| image:: images/upload.png
+
+Use the ``New Folder`` icon |folder| to add a new folder.
+
+.. |folder| image:: images/folder.png
+
+Use the ``Grid View`` icon |gridview| to display all the files and folders in a grid view.
+
+.. |gridview| image:: images/gridview.png
+
+Use the ``Table View`` icon |tableview| to display all the files and folders in a list view.
+
+.. |tableview| image:: images/tableview.png
+
+Click on the check box next to *Show hidden files and folders* at the bottom of the window to view hidden files and folders.
+
+Use the *Format* drop down list to select the format of the files to be displayed; choose from *sql*, *csv*, or *All Files*.
+
+You can also download backup files through *Storage Manager* at the successful completion of the backups taken through :ref:`Backup Dialog <backup_dialog>`, :ref:`Backup Global Dialog <backup_globals_dialog>`, or :ref:`Backup Server Dialog <backup_server_dialog>`.
+
+At the successful completion of a backup, click on the icon to open the current backup file in *Storage Manager* on the *process watcher* window.
+
+.. image:: images/process_watcher_storage_manager.png
+    :alt: Process watcher with storage manager icon
+    :align: center